=== debian/changelog ===
meshoptimizer (0.15+dfsg-3) unstable; urgency=medium

  * Fix keyword error in d/watch

 -- Timo Röhling <timo@gaussglocke.de>  Thu, 07 Jan 2021 17:32:18 +0100

meshoptimizer (0.15+dfsg-2) unstable; urgency=medium

  * Source only upload.

 -- Timo Röhling <timo@gaussglocke.de>  Fri, 25 Dec 2020 16:50:50 +0100

meshoptimizer (0.15+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #977129)

 -- Timo Röhling <timo@gaussglocke.de>  Sun, 13 Dec 2020 20:29:32 +0100
