=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all future=+lfs

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DMESHOPT_BUILD_DEMO=OFF \
		-DMESHOPT_BUILD_GLTFPACK=ON \
		-DMESHOPT_BUILD_SHARED_LIBS=ON \
		-DCMAKE_SKIP_RPATH=ON
