=== debian/changelog ===
meshoptimizer (0.16+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Sun, 15 Aug 2021 23:01:24 +0200

meshoptimizer (0.16+dfsg-1) experimental; urgency=medium

  * New upstream version 0.16+dfsg
  * Bump SOVERSION to 1d
  * Update maintainer info

 -- Timo Röhling <roehling@debian.org>  Thu, 03 Jun 2021 07:40:35 +0200
