=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: meshoptimizer
 Section: graphics
 Priority: optional
-Maintainer: Timo Röhling <timo@gaussglocke.de>
+Maintainer: Timo Röhling <roehling@debian.org>
 Build-Depends: debhelper-compat (= 13), cmake
 Homepage: https://github.com/zeux/meshoptimizer
 Standards-Version: 4.5.1
@@ -9,7 +9,7 @@
 Vcs-Git: https://salsa.debian.org/roehling/meshoptimizer.git
 Vcs-Browser: https://salsa.debian.org/roehling/meshoptimizer
 
-Package: libmeshoptimizer0d
+Package: libmeshoptimizer1d
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -25,7 +25,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libmeshoptimizer0d (= ${binary:Version}), ${misc:Depends}
+Depends: libmeshoptimizer1d (= ${binary:Version}), ${misc:Depends}
 Description: Mesh optimizing library for 3D object rendering - development headers
  When a GPU renders triangle meshes, various stages of the GPU pipeline have
  to process vertex and index data. The efficiency of these stages depends on
