=== debian/changelog ===
meshoptimizer (0.17+dfsg-1) unstable; urgency=medium

  * New upstream version 0.17+dfsg
  * Refresh patches
  * Add .symbols file
  * Bump Standards-Version to 4.6.0
  * Update d/copyright

 -- Timo Röhling <roehling@debian.org>  Thu, 25 Nov 2021 13:02:03 +0100
