=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Timo Röhling <roehling@debian.org>
 Build-Depends: debhelper-compat (= 13), cmake
 Homepage: https://github.com/zeux/meshoptimizer
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/roehling/meshoptimizer.git
 Vcs-Browser: https://salsa.debian.org/roehling/meshoptimizer
