=== debian/changelog ===
meshoptimizer (0.18+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Sun, 07 Aug 2022 22:38:11 +0200

meshoptimizer (0.18+dfsg-1) experimental; urgency=medium

  * Set upstream metadata fields
  * New upstream version 0.18+dfsg
  * Bump SONAME after ABI change
  * Bump Standards-Version to 4.6.1

 -- Timo Röhling <roehling@debian.org>  Thu, 04 Aug 2022 22:45:53 +0200
