=== debian/rules ===
--- 
+++ 
@@ -10,5 +10,5 @@
 		-DMESHOPT_BUILD_DEMO=OFF \
 		-DMESHOPT_BUILD_GLTFPACK=ON \
 		-DMESHOPT_BUILD_SHARED_LIBS=ON \
-		-DMESHOPT_SOVERSION=1d \
+		-DMESHOPT_SOVERSION=2d \
 		-DCMAKE_SKIP_RPATH=ON
