=== debian/changelog ===
meshoptimizer (0.19+dfsg-1) unstable; urgency=medium

  * Fix d/watch
  * New upstream version 0.19+dfsg
  * Refresh patches
  * Bump experimental symbol
  * Update d/copyright
  * Bump Standards-Version to 4.6.2

 -- Timo Röhling <roehling@debian.org>  Tue, 27 Jun 2023 00:30:49 +0200
