=== debian/changelog ===
meshoptimizer (0.20+dfsg-1) unstable; urgency=medium

  * New upstream version 0.20+dfsg
  * Update d/symbols

 -- Timo Röhling <roehling@debian.org>  Mon, 06 Nov 2023 19:10:42 +0100
