=== debian/changelog ===
meshoptimizer (0.21+dfsg-1) unstable; urgency=medium

  * New upstream version 0.21+dfsg
  * Refresh patches (no functional changes)
  * Update d/copyright
  * Update d/symbols

 -- Timo Röhling <roehling@debian.org>  Sat, 29 Jun 2024 22:40:32 +0200
