=== debian/changelog ===
meshoptimizer (0.22+dfsg-1) unstable; urgency=medium

  * Update d/watch to latest GitHub recipe
  * New upstream version 0.22+dfsg
  * Refresh patches (no functional changes)
  * Update d/symbols
  * Bump Standards-Version to 4.7.0
  * Wrap and sort Debian package files

 -- Timo Röhling <roehling@debian.org>  Fri, 29 Nov 2024 11:39:33 +0100
