=== debian/control ===
Source: meshoptimizer
Section: graphics
Priority: optional
Maintainer: Timo Röhling <roehling@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
Homepage: https://github.com/zeux/meshoptimizer
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/roehling/meshoptimizer.git
Vcs-Browser: https://salsa.debian.org/roehling/meshoptimizer

Package: libmeshoptimizer2d
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Mesh optimizing library for 3D object rendering
 When a GPU renders triangle meshes, various stages of the GPU pipeline have
 to process vertex and index data. The efficiency of these stages depends on
 the data you feed to them; this library provides algorithms to help optimize
 meshes for these stages, as well as algorithms to reduce the mesh complexity
 and storage overhead.

Package: gltfpack
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: glTF mesh file optimizer
 gltfpack is a tool that can automatically optimize glTF files to reduce the
 download size and improve loading and rendering speed.
 .
 It substantially changes the glTF data by optimizing the meshes for
 vertex fetch and transform cache, quantizing the geometry to reduce the
 memory consumption and size, merging meshes to reduce the draw call count,
 quantizing and resampling animations to reduce animation size and simplify
 playback, and pruning the node tree by removing or collapsing redundant
 nodes. It will also simplify the meshes when requested to do so.

Package: libmeshoptimizer-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libmeshoptimizer2d (= ${binary:Version}),
 ${misc:Depends},
Description: Mesh optimizing library for 3D object rendering - development headers
 When a GPU renders triangle meshes, various stages of the GPU pipeline have
 to process vertex and index data. The efficiency of these stages depends on
 the data you feed to them; this library provides algorithms to help optimize
 meshes for these stages, as well as algorithms to reduce the mesh complexity
 and storage overhead.
 .
 This package provides the development headers for the library.
