## meshoptimizer 0.25%2Bdfsg

=== debian/changelog ===
meshoptimizer (0.25+dfsg-1) experimental; urgency=medium

  * Migrate debian/watch to version 5 format
  * New upstream version 0.25+dfsg
  * Update patches
    - Obsolete: 0002-Remove-debug-code.patch
  * Wrap and sort Debian files
  * Bump Standards-Version to 4.7.2
  * Bump SONAME to 3d

 -- Timo Röhling <roehling@debian.org>  Tue, 16 Sep 2025 22:07:45 +0200
